/*
 * Top Level of a Time to digital converter for low-frequency called Crono TDC LF.
 * 
 * This module is the Vivado top-level of the Crono TDC Arty A7.
 * This project is aimed to be used with the Arty A7-35 board.
 * Here, we generate some pulses with the FPGA and introduce them into the the
 * TDC Channels input using **TBD** interface.
 * Arty A7 have exposed this interfaces in it's hihg-speed Pmods: JB & JC.
 *
 * Author: Julian Rodriguez <jnrodriguez@estudiantes.unsam.edu.ar>
 */

module top_level_crono_tdc(i_rx_serial,i_base_clk,i_aux_clk,o_tx_serial,i_reset,o_led,
    i_channels_inputs_p, i_channels_inputs_n, o_pattern_generator_p, o_pattern_generator_n
);
    /* Useful local parameters (just to not use magic numbers). */
    localparam WORKING_TDC_CHANNEL_QTY = 17;  // TDC used channels
    localparam TDC_CHANNEL_QTY = WORKING_TDC_CHANNEL_QTY+1; // we always will have a test channel (channel 0)

    /* TDC inputs parameters. */
    parameter TDC_CHANNEL_RAM_ADDR_WIDTH = 14;
    parameter TDC_CHANNEL_DATA_REG_WIDTH = 18; // width of channels inputs RAM rows
    parameter TDC_CHANNEL_RAM_SIZE = 2048; // quantity of rows of channels inputs RAM
    /* TDC Config registers parameters. */
    parameter CFG_REG_INIT_VAL_TIME_WINDOWS_US = 1000000;
    parameter CFG_REG_INIT_VAL_ENABLED_CHN = {TDC_CHANNEL_QTY{1'b1}}; // all channels are enabled by default
    /* UART parameters. */
    parameter UART_BAUDRATE = 115200;

    /* Useful local parameters (just to not use magic numbers). */
    localparam SYSTEM_CLOCK_FREQUENCY_HZ = 50000000;
    localparam HDLC_LITE_FRAME_MAX_WIDTH_BYTES = 32; // NOTE: do not increment this because can lead to timing failures (big internal buffers drived by a single counter)
    localparam HDLC_LITE_FRAME_DATA_MAX_WIDTH_BYTES         = HDLC_LITE_FRAME_MAX_WIDTH_BYTES-4;
    localparam HDLC_LITE_FRAME_DATA_HALF_MAX_WIDTH_BYTES    = HDLC_LITE_FRAME_DATA_MAX_WIDTH_BYTES/2;

    input i_rx_serial;          // uart RX
    output o_tx_serial;         // uart TX 
    input i_base_clk;           // base clock generated externally and introduced into fpga
    input i_aux_clk;            // aux clock generated externally and introduced into fpga
    input i_reset;              // reset signal (active-high)
    output [1:0] o_led;         // leds
    input [TDC_CHANNEL_QTY-1:0] i_channels_inputs_p; // positive inputs used to measure signals
    input [TDC_CHANNEL_QTY-1:0] i_channels_inputs_n; // negative inputs used to measure signals
    output o_pattern_generator_p; // positive output used to transmit test pattern signal
    output o_pattern_generator_n; // negative output used to transmit test pattern signal

    /*- Clock generation ----------------------------------------------------*/
    /* We generate 5 clock signals:
     * w_clk: this one will feed the general system of crono TDC 
     * (tdc_core_logic, hdlc_lite_processor, uart, etc...)
     * w_serdes_clk: serdes base clock (0 phaseshift)
     * w_serdes_oclk: serdes 90 grades phaseshift
     * w_serdes_clkb: serdes 180 grades phaseshift
     * w_serdes_oclkb: serdes 270 grades phaseshift.
     * We are separating serdes clock and the general clock to give the more 
     * pure clock to iserdese. The w_serdes_clk and w_clk must be in phase 
     * because are generated by the same MCMM. */
    wire w_clk; // system clock for all the rest of the system
    wire w_serdes_clk_pre_buffer, w_serdes_clk, w_serdes_clkb, w_serdes_oclk_pre_buffer, w_serdes_oclk, w_serdes_oclkb;

    // Note: in xilinx forums we found that ISERDESE IP core will not work with mmcm that is generating
    // the four clock signals. We need to generate only two clock signals and use an inverter to generate the other two.
    // source0:https://support.xilinx.com/s/question/0D52E00007IPcWwSAL/understanding-iserdes-oversample-mode?language=en_US
    // source1:https://support.xilinx.com/s/question/0D52E00006hpjKbSAI/iserdes-clocking-in-oversample-mode?language=en_US
    // From UG471:
    // • CLK and CLKB are driven by a BUFIO. OCLK and OCLKB are driven by a BUFIO that is
    // phase shifted by 90°. The two BUFIOs are driven from a single MMCM.
    // • CLK and CLKB are driven by a BUFG. OCLK and OCLKB are driven by a BUFG that is
    // phase shifted by 90°. The BUFGs are driven from a single MMCM. 
    // In either case, the effective clocking is:
    // • CLK: 0°
    // • OCLK: 90°
    // • CLKB: 180°
    // • OCLKB: 270°
    clk_wiz_0 base_clock_gen(
        .o_clk(w_clk),   // output o_clk
        .o_serdes_clk(w_serdes_clk_pre_buffer),     // serdes oclk (0)
        .o_serdes_oclk(w_serdes_oclk_pre_buffer),   // serdes o_oclk (90)
        .reset(i_reset),                // input reset
        .locked(),
        .i_clk(i_base_clk)  // input clock
    );

    BUFG bufio_clk (
    .O(w_serdes_clk), // 1-bit output: Clock output (connect to I/O clock loads).
    .I(w_serdes_clk_pre_buffer)  // 1-bit input: Clock input (connect to an IBUF or BUFMR).
    );   
    assign w_serdes_clkb = ~w_serdes_clk;

    BUFG bufio_oclk (
    .O(w_serdes_oclk), // 1-bit output: Clock output (connect to I/O clock loads).
    .I(w_serdes_oclk_pre_buffer)  // 1-bit input: Clock input (connect to an IBUF or BUFMR).
    );   
    assign w_serdes_oclkb = ~w_serdes_oclk;

    /*- Channels inputs generation ------------------------------------------*/
    wire [HDLC_LITE_FRAME_DATA_MAX_WIDTH_BYTES*8-1:0] w_core_logic_rx_data;
    wire [HDLC_LITE_FRAME_DATA_HALF_MAX_WIDTH_BYTES*8-1:0] w_core_logic_tx_data;
    wire [TDC_CHANNEL_QTY-1:0] w_channels_inputs; // array with channels inputs

    // Differential input buffers.
    genvar i;
    generate
        for(i = 0; i < TDC_CHANNEL_QTY; i = i + 1) begin
            IBUFDS IBUFDS_inst (
                .O(w_channels_inputs[i]),   // 1-bit output: Buffer output
                .I(i_channels_inputs_p[i]),  // 1-bit input: Diff_p buffer input (connect directly to top-level port)
                .IB(i_channels_inputs_n[i])  // 1-bit input: Diff_n buffer input (connect directly to top-level port)
            );
        end
    endgenerate

    /*- Pattern generator -----------------------------------------------------*/
    wire w_aux_clk, w_pattern_generator_out;

    clk_wiz_1 aux_clock_gen(
        .o_clk(w_aux_clk),      // auxiliary clock
        .reset(i_reset),                // input reset
        .locked(),
        .i_clk(i_aux_clk)  // input clock
    );
    
    // Pattern generator used to test Crono TDC functionality.
    // First base clock period is not working! put 1 clock of "dummy" data
    pattern_generator #(
        .PATTERN_SIZE(32),
        .PATTERN(32'b00000100010001000110010101001110)
    ) pattern_generator0 (
        .i_start(w_measure_ongoing),
        .i_clk(w_aux_clk),
        .i_reset(i_reset),
        .o_pattern(w_pattern_generator_out)
    );

    // Pattern generator output diferential buffers.
    OBUFDS OBUFDS_inst (
      .O(o_pattern_generator_p),    // Diff_p output (connect directly to top-level port)
      .OB(o_pattern_generator_n),   // Diff_n output (connect directly to top-level port)
      .I(w_pattern_generator_out)   // Buffer input
    );

    /*- Crono TDC Core instantiation ----------------------------------------*/
    crono_tdc #(
        .HDLC_LITE_TX_FRAME_MAX_WIDTH_BYTES(HDLC_LITE_FRAME_MAX_WIDTH_BYTES),
        .TDC_CHANNEL_QTY(TDC_CHANNEL_QTY),
        .TDC_CHANNEL_RAM_ADDR_WIDTH(TDC_CHANNEL_RAM_ADDR_WIDTH),
        .TDC_CHANNEL_DATA_REG_WIDTH(TDC_CHANNEL_DATA_REG_WIDTH),
        .TDC_CHANNEL_RAM_SIZE(TDC_CHANNEL_RAM_SIZE),
        .CFG_REG_INIT_VAL_TIME_WINDOWS_US(CFG_REG_INIT_VAL_TIME_WINDOWS_US),
        .CFG_REG_INIT_VAL_ENABLED_CHN(CFG_REG_INIT_VAL_ENABLED_CHN),
        .UART_BAUDRATE(UART_BAUDRATE),
        .SYSTEM_CLOCK_FREQUENCY_HZ(SYSTEM_CLOCK_FREQUENCY_HZ)
    )crono_tdc(
        .i_reset(i_reset),
        .i_clk(w_clk),
        .i_serdes_clk(w_serdes_clk),
        .i_serdes_oclk(w_serdes_oclk),
        .i_serdes_clkb(w_serdes_clkb),
        .i_serdes_oclkb(w_serdes_oclkb),
        .i_rx_serial(i_rx_serial),
        .o_tx_serial(o_tx_serial),
        .i_channels_inputs(w_channels_inputs),
        .o_measure_ongoing(w_measure_ongoing),
        .o_flags()
    );

    assign o_led[1] = w_measure_ongoing; // led1 will be turned on when tdc is measuring

    /* Simple led that toggles every DEBUG_LED0_TOGGLE_PERIOD_MS milliseconds. */
    timed_toggler #(
        .TOGGLE_PERIOD_MS(1000),
        .CLOCK_FREQUENCY_HZ(SYSTEM_CLOCK_FREQUENCY_HZ)
    ) debug_led_blinker (
        .i_clk          (w_clk),
        .i_reset        (i_reset),
        .o_toggle_out   (o_led[0])
    );


// the "macro" to dump signals
`ifdef COCOTB_SIM
initial begin
  $dumpfile ("top_level_crono_tdc.vcd");
  $dumpvars (0, top_level_crono_tdc);
  #1;
end

`else

    /* ILA instantiation if we are debugging this module with Vivado */
    //`define DEBUG_TOP_LEVEL_CRONO_TDC
    `ifdef DEBUG_TOP_LEVEL_CRONO_TDC
    ila_0 ila_top_level_crono_tdc (
        .clk(w_pattern_clock), // input wire clk
        .probe0(w_measure_ongoing),         // 1bit
        .probe1(w_pattern0_generator_out),  // 1bit
        .probe2(w_channels_inputs)         // 1bit
    );
    `endif


`endif

endmodule
